# Design

## Key sharing

I maintain a number of GPG keys for different purposes, from signing keys for
work and personal use, to encryption keys for communication, and so on.

Having several keys makes it easy to maintain different levels of security,
different expirations, differnet rotation strategies, and so on.

The hard part is this -- how can you conveniently, securely transfer keys
between multiple machines?

Ideally it would be something like Dropbox, all that would be required would be
to drop keys into one place and they'd automatically get moved around, no
problem.

The problem is that now your private keys are on a remote machine -- that sucks,
we don't want that, so instead we can use Bittorrent Sync.

Even then, we've only got one level of encryption, and though I'm sure BTSync is
pretty good, my level of paranoia is a few ticks higher. Instead, we can further
encrypt these keys with public keys for the target machines. Essentially, an
otherwise unpublished public key for each machine in the sharing ring. These
keys are transferred by you, and only you, by sneakernet, scp, whatever. I use
BTSync to sync the public keys. Locksmith runs on each machine as a daemon, when
it sees a new public key, it automatically imports it to the local keyring
(again, these keys are not shared), it then encrypts all the local keys listed
in the .localkeys file in the directory specified by the configuration. These
keys are put in a folder which is watched by the new machine.
